﻿
'------------------------------------------------------------------------------
' <auto-generated>
'     This code was generated by a tool.
'
'     Changes to this file may cause incorrect behavior and will be lost if
'     the code is regenerated.
' </auto-generated>
'------------------------------------------------------------------------------

Option Strict On
Option Explicit On

Imports __SalesOrderHeader = LightSwitchApplication.SalesOrderHeader

Namespace LightSwitchApplication

    #Region "Entities"
    
    ''' <summary>
    ''' No Modeled Description Available
    ''' </summary>
    <Global.System.CodeDom.Compiler.GeneratedCodeAttribute("Microsoft.LightSwitch.BuildTasks.CodeGen", "11.0.0.0")> _
    Public NotInheritable Partial Class SalesOrderHeader
        Inherits Global.Microsoft.LightSwitch.Framework.Base.EntityObject(Of __SalesOrderHeader, __SalesOrderHeader.DetailsClass)
    
        #Region "Constructors"
    
        ''' <summary>
        ''' Initializes a new instance of the SalesOrderHeader entity.
        ''' </summary>
        <Global.System.CodeDom.Compiler.GeneratedCodeAttribute("Microsoft.LightSwitch.BuildTasks.CodeGen", "11.0.0.0")> _
        <Global.System.Diagnostics.DebuggerNonUserCodeAttribute()> _
        Public Sub New()
            Me.New(Nothing)
        End Sub
    
        <Global.System.CodeDom.Compiler.GeneratedCodeAttribute("Microsoft.LightSwitch.BuildTasks.CodeGen", "11.0.0.0")> _
        <Global.System.Diagnostics.DebuggerNonUserCodeAttribute()> _
        Public Sub New(entitySet As Global.Microsoft.LightSwitch.Framework.EntitySet(Of __SalesOrderHeader))
            MyBase.New(entitySet)
            
            __SalesOrderHeader.DetailsClass.Initialize(Me)
        End Sub
    
        <Global.System.ComponentModel.EditorBrowsable(Global.System.ComponentModel.EditorBrowsableState.Advanced)> _
        Private Partial Sub SalesOrderHeader_Created()
        End Sub
        <Global.System.ComponentModel.EditorBrowsable(Global.System.ComponentModel.EditorBrowsableState.Advanced)> _
        Private Partial Sub SalesOrderHeader_AllowSaveWithErrors(ByRef result As Boolean)
        End Sub
    
        #End Region
    
        #Region "Private Properties"
        
        ''' <summary>
        ''' Gets the Application object for this application.  The Application object provides access to active screens, methods to open screens and access to the current user.
        ''' </summary>
        <Global.System.CodeDom.Compiler.GeneratedCodeAttribute("Microsoft.LightSwitch.BuildTasks.CodeGen", "11.0.0.0")> _
        <Global.System.Diagnostics.DebuggerNonUserCodeAttribute()> _
        Private ReadOnly Property Application As Global.Microsoft.LightSwitch.IApplication(Of Global.LightSwitchApplication.DataWorkspace)
            Get
                Return Global.LightSwitchApplication.Application.Current
            End Get
        End Property
        
        ''' <summary>
        ''' Gets the containing data workspace.  The data workspace provides access to all data sources in the application.
        ''' </summary>
        <Global.System.CodeDom.Compiler.GeneratedCodeAttribute("Microsoft.LightSwitch.BuildTasks.CodeGen", "11.0.0.0")> _
        <Global.System.Diagnostics.DebuggerNonUserCodeAttribute()> _
        Private ReadOnly Property DataWorkspace As Global.LightSwitchApplication.DataWorkspace
            Get
                Return DirectCast(Me.Details.EntitySet.Details.DataService.Details.DataWorkspace, Global.LightSwitchApplication.DataWorkspace)
            End Get
        End Property
        
        #End Region
    
        #Region "Public Properties"
    
        ''' <summary>
        ''' No Modeled Description Available
        ''' </summary>
        <Global.System.CodeDom.Compiler.GeneratedCodeAttribute("Microsoft.LightSwitch.BuildTasks.CodeGen", "11.0.0.0")> _
        <Global.System.Diagnostics.DebuggerNonUserCodeAttribute()> _
        Public Property Id As Integer
            Get
                Return __SalesOrderHeader.DetailsClass.GetValue(Me, __SalesOrderHeader.DetailsClass.PropertySetProperties.Id)
            End Get
            Set
                __SalesOrderHeader.DetailsClass.SetValue(Me, __SalesOrderHeader.DetailsClass.PropertySetProperties.Id, Value)
            End Set
        End Property
        
        <Global.System.ComponentModel.EditorBrowsable(Global.System.ComponentModel.EditorBrowsableState.Advanced)> _
        Private Partial Sub Id_IsReadOnly(ByRef result As Boolean)
        End Sub
        <Global.System.ComponentModel.EditorBrowsable(Global.System.ComponentModel.EditorBrowsableState.Advanced)> _
        Private Partial Sub Id_Validate(ByVal results As Global.Microsoft.LightSwitch.EntityValidationResultsBuilder)
        End Sub
        <Global.System.ComponentModel.EditorBrowsable(Global.System.ComponentModel.EditorBrowsableState.Advanced)> _
        Private Partial Sub Id_Changed()
        End Sub

        ''' <summary>
        ''' No Modeled Description Available
        ''' </summary>
        <Global.System.ComponentModel.EditorBrowsable(Global.System.ComponentModel.EditorBrowsableState.Advanced)> _
        <Global.System.CodeDom.Compiler.GeneratedCodeAttribute("Microsoft.LightSwitch.BuildTasks.CodeGen", "11.0.0.0")> _
        <Global.System.Diagnostics.DebuggerNonUserCodeAttribute()> _
        Public Property RowVersion As Byte()
            Get
                Return __SalesOrderHeader.DetailsClass.GetValue(Me, __SalesOrderHeader.DetailsClass.PropertySetProperties.RowVersion)
            End Get
            Set
                __SalesOrderHeader.DetailsClass.SetValue(Me, __SalesOrderHeader.DetailsClass.PropertySetProperties.RowVersion, Value)
            End Set
        End Property
        
        <Global.System.ComponentModel.EditorBrowsable(Global.System.ComponentModel.EditorBrowsableState.Advanced)> _
        Private Partial Sub RowVersion_IsReadOnly(ByRef result As Boolean)
        End Sub
        <Global.System.ComponentModel.EditorBrowsable(Global.System.ComponentModel.EditorBrowsableState.Advanced)> _
        Private Partial Sub RowVersion_Validate(ByVal results As Global.Microsoft.LightSwitch.EntityValidationResultsBuilder)
        End Sub
        <Global.System.ComponentModel.EditorBrowsable(Global.System.ComponentModel.EditorBrowsableState.Advanced)> _
        Private Partial Sub RowVersion_Changed()
        End Sub

        ''' <summary>
        ''' No Modeled Description Available
        ''' </summary>
        <Global.System.CodeDom.Compiler.GeneratedCodeAttribute("Microsoft.LightSwitch.BuildTasks.CodeGen", "11.0.0.0")> _
        <Global.System.Diagnostics.DebuggerNonUserCodeAttribute()> _
        Public Property OrderDate As Date
            Get
                Return __SalesOrderHeader.DetailsClass.GetValue(Me, __SalesOrderHeader.DetailsClass.PropertySetProperties.OrderDate)
            End Get
            Set
                __SalesOrderHeader.DetailsClass.SetValue(Me, __SalesOrderHeader.DetailsClass.PropertySetProperties.OrderDate, Value)
            End Set
        End Property
        
        <Global.System.ComponentModel.EditorBrowsable(Global.System.ComponentModel.EditorBrowsableState.Advanced)> _
        Private Partial Sub OrderDate_IsReadOnly(ByRef result As Boolean)
        End Sub
        <Global.System.ComponentModel.EditorBrowsable(Global.System.ComponentModel.EditorBrowsableState.Advanced)> _
        Private Partial Sub OrderDate_Validate(ByVal results As Global.Microsoft.LightSwitch.EntityValidationResultsBuilder)
        End Sub
        <Global.System.ComponentModel.EditorBrowsable(Global.System.ComponentModel.EditorBrowsableState.Advanced)> _
        Private Partial Sub OrderDate_Changed()
        End Sub

        ''' <summary>
        ''' No Modeled Description Available
        ''' </summary>
        <Global.System.CodeDom.Compiler.GeneratedCodeAttribute("Microsoft.LightSwitch.BuildTasks.CodeGen", "11.0.0.0")> _
        <Global.System.Diagnostics.DebuggerNonUserCodeAttribute()> _
        Public ReadOnly Property OrderTotal As Decimal
            Get
                Return __SalesOrderHeader.DetailsClass.GetValue(Me, __SalesOrderHeader.DetailsClass.PropertySetProperties.OrderTotal)
            End Get
        End Property
        
        <Global.System.ComponentModel.EditorBrowsable(Global.System.ComponentModel.EditorBrowsableState.Advanced)> _
        Private Partial Sub OrderTotal_Compute(ByRef result As Decimal)
        End Sub
        <Global.System.ComponentModel.EditorBrowsable(Global.System.ComponentModel.EditorBrowsableState.Advanced)> _
        Private Partial Sub OrderTotal_Validate(ByVal results As Global.Microsoft.LightSwitch.EntityValidationResultsBuilder)
        End Sub

        ''' <summary>
        ''' No Modeled Description Available
        ''' </summary>
        <Global.System.CodeDom.Compiler.GeneratedCodeAttribute("Microsoft.LightSwitch.BuildTasks.CodeGen", "11.0.0.0")> _
        <Global.System.Diagnostics.DebuggerNonUserCodeAttribute()> _
        Public Property AmountPaid As Decimal
            Get
                Return __SalesOrderHeader.DetailsClass.GetValue(Me, __SalesOrderHeader.DetailsClass.PropertySetProperties.AmountPaid)
            End Get
            Set
                __SalesOrderHeader.DetailsClass.SetValue(Me, __SalesOrderHeader.DetailsClass.PropertySetProperties.AmountPaid, Value)
            End Set
        End Property
        
        <Global.System.ComponentModel.EditorBrowsable(Global.System.ComponentModel.EditorBrowsableState.Advanced)> _
        Private Partial Sub AmountPaid_IsReadOnly(ByRef result As Boolean)
        End Sub
        <Global.System.ComponentModel.EditorBrowsable(Global.System.ComponentModel.EditorBrowsableState.Advanced)> _
        Private Partial Sub AmountPaid_Validate(ByVal results As Global.Microsoft.LightSwitch.EntityValidationResultsBuilder)
        End Sub
        <Global.System.ComponentModel.EditorBrowsable(Global.System.ComponentModel.EditorBrowsableState.Advanced)> _
        Private Partial Sub AmountPaid_Changed()
        End Sub

        ''' <summary>
        ''' No Modeled Description Available
        ''' </summary>
        <Global.System.CodeDom.Compiler.GeneratedCodeAttribute("Microsoft.LightSwitch.BuildTasks.CodeGen", "11.0.0.0")> _
        <Global.System.Diagnostics.DebuggerNonUserCodeAttribute()> _
        Public ReadOnly Property AmountDue As Decimal
            Get
                Return __SalesOrderHeader.DetailsClass.GetValue(Me, __SalesOrderHeader.DetailsClass.PropertySetProperties.AmountDue)
            End Get
        End Property
        
        <Global.System.ComponentModel.EditorBrowsable(Global.System.ComponentModel.EditorBrowsableState.Advanced)> _
        Private Partial Sub AmountDue_Compute(ByRef result As Decimal)
        End Sub
        <Global.System.ComponentModel.EditorBrowsable(Global.System.ComponentModel.EditorBrowsableState.Advanced)> _
        Private Partial Sub AmountDue_Validate(ByVal results As Global.Microsoft.LightSwitch.EntityValidationResultsBuilder)
        End Sub

        ''' <summary>
        ''' No Modeled Description Available
        ''' </summary>
        <Global.System.CodeDom.Compiler.GeneratedCodeAttribute("Microsoft.LightSwitch.BuildTasks.CodeGen", "11.0.0.0")> _
        <Global.System.Diagnostics.DebuggerNonUserCodeAttribute()> _
        Public Property Customer As Global.LightSwitchApplication.Customer
            Get
                Return __SalesOrderHeader.DetailsClass.GetValue(Me, __SalesOrderHeader.DetailsClass.PropertySetProperties.Customer)
            End Get
            Set
                __SalesOrderHeader.DetailsClass.SetValue(Me, __SalesOrderHeader.DetailsClass.PropertySetProperties.Customer, Value)
            End Set
        End Property
        
        <Global.System.ComponentModel.EditorBrowsable(Global.System.ComponentModel.EditorBrowsableState.Advanced)> _
        Private Partial Sub Customer_IsReadOnly(ByRef result As Boolean)
        End Sub
        <Global.System.ComponentModel.EditorBrowsable(Global.System.ComponentModel.EditorBrowsableState.Advanced)> _
        Private Partial Sub Customer_Validate(ByVal results As Global.Microsoft.LightSwitch.EntityValidationResultsBuilder)
        End Sub
        <Global.System.ComponentModel.EditorBrowsable(Global.System.ComponentModel.EditorBrowsableState.Advanced)> _
        Private Partial Sub Customer_Changed()
        End Sub

        ''' <summary>
        ''' No Modeled Description Available
        ''' </summary>
        <Global.System.CodeDom.Compiler.GeneratedCodeAttribute("Microsoft.LightSwitch.BuildTasks.CodeGen", "11.0.0.0")> _
        <Global.System.Diagnostics.DebuggerNonUserCodeAttribute()> _
        Public Property Employee As Global.LightSwitchApplication.Employee
            Get
                Return __SalesOrderHeader.DetailsClass.GetValue(Me, __SalesOrderHeader.DetailsClass.PropertySetProperties.Employee)
            End Get
            Set
                __SalesOrderHeader.DetailsClass.SetValue(Me, __SalesOrderHeader.DetailsClass.PropertySetProperties.Employee, Value)
            End Set
        End Property
        
        <Global.System.ComponentModel.EditorBrowsable(Global.System.ComponentModel.EditorBrowsableState.Advanced)> _
        Private Partial Sub Employee_IsReadOnly(ByRef result As Boolean)
        End Sub
        <Global.System.ComponentModel.EditorBrowsable(Global.System.ComponentModel.EditorBrowsableState.Advanced)> _
        Private Partial Sub Employee_Validate(ByVal results As Global.Microsoft.LightSwitch.EntityValidationResultsBuilder)
        End Sub
        <Global.System.ComponentModel.EditorBrowsable(Global.System.ComponentModel.EditorBrowsableState.Advanced)> _
        Private Partial Sub Employee_Changed()
        End Sub

        ''' <summary>
        ''' No Modeled Description Available
        ''' </summary>
        <Global.System.CodeDom.Compiler.GeneratedCodeAttribute("Microsoft.LightSwitch.BuildTasks.CodeGen", "11.0.0.0")> _
        <Global.System.Diagnostics.DebuggerNonUserCodeAttribute()> _
        Public ReadOnly Property SalesOrderDetails As Global.Microsoft.LightSwitch.Framework.EntityCollection(Of Global.LightSwitchApplication.SalesOrderDetail)
            Get
                Return __SalesOrderHeader.DetailsClass.GetValue(Me, __SalesOrderHeader.DetailsClass.PropertySetProperties.SalesOrderDetails)
            End Get
        End Property
        
        <Global.System.CodeDom.Compiler.GeneratedCodeAttribute("Microsoft.LightSwitch.BuildTasks.CodeGen", "11.0.0.0")> _
        <Global.System.Diagnostics.DebuggerNonUserCodeAttribute()> _
        Public ReadOnly Property SalesOrderDetailsQuery As Microsoft.LightSwitch.IDataServiceQueryable(Of Global.LightSwitchApplication.SalesOrderDetail)
            Get
                Return __SalesOrderHeader.DetailsClass.GetQuery(Me, __SalesOrderHeader.DetailsClass.PropertySetProperties.SalesOrderDetails)
            End Get
        End Property

        ''' <summary>
        ''' No Modeled Description Available
        ''' </summary>
        <Global.System.CodeDom.Compiler.GeneratedCodeAttribute("Microsoft.LightSwitch.BuildTasks.CodeGen", "11.0.0.0")> _
        <Global.System.Diagnostics.DebuggerNonUserCodeAttribute()> _
        Public ReadOnly Property OrderPayments As Global.Microsoft.LightSwitch.Framework.EntityCollection(Of Global.LightSwitchApplication.OrderPayment)
            Get
                Return __SalesOrderHeader.DetailsClass.GetValue(Me, __SalesOrderHeader.DetailsClass.PropertySetProperties.OrderPayments)
            End Get
        End Property
        
        <Global.System.CodeDom.Compiler.GeneratedCodeAttribute("Microsoft.LightSwitch.BuildTasks.CodeGen", "11.0.0.0")> _
        <Global.System.Diagnostics.DebuggerNonUserCodeAttribute()> _
        Public ReadOnly Property OrderPaymentsQuery As Microsoft.LightSwitch.IDataServiceQueryable(Of Global.LightSwitchApplication.OrderPayment)
            Get
                Return __SalesOrderHeader.DetailsClass.GetQuery(Me, __SalesOrderHeader.DetailsClass.PropertySetProperties.OrderPayments)
            End Get
        End Property

        #End Region
    
        #Region "Details Class"
    
        <Global.System.ComponentModel.EditorBrowsable(Global.System.ComponentModel.EditorBrowsableState.Never)> _
        <Global.System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Design", "CA1034:NestedTypesShouldNotBeVisible")> _
        <Global.System.CodeDom.Compiler.GeneratedCodeAttribute("Microsoft.LightSwitch.BuildTasks.CodeGen", "11.0.0.0")> _
        <Global.System.Diagnostics.DebuggerNonUserCodeAttribute()> _
        Public NotInheritable Class DetailsClass
            Inherits Global.Microsoft.LightSwitch.Details.Framework.Base.EntityDetails(Of _
                __SalesOrderHeader, _
                __SalesOrderHeader.DetailsClass, _
                __SalesOrderHeader.DetailsClass.IImplementation, _
                __SalesOrderHeader.DetailsClass.PropertySet, _
                Global.Microsoft.LightSwitch.Details.Framework.EntityCommandSet(Of __SalesOrderHeader, __SalesOrderHeader.DetailsClass), _
                Global.Microsoft.LightSwitch.Details.Framework.EntityMethodSet(Of __SalesOrderHeader, __SalesOrderHeader.DetailsClass))
    
            Shared Sub New()
                Dim initializeEntry = __SalesOrderHeader.DetailsClass.PropertySetProperties.Id
            End Sub
    
            <Global.System.Diagnostics.DebuggerBrowsable(Global.System.Diagnostics.DebuggerBrowsableState.Never)> _
            Private Shared ReadOnly __SalesOrderHeaderEntry As Global.Microsoft.LightSwitch.Details.Framework.Base.EntityDetails(Of __SalesOrderHeader, __SalesOrderHeader.DetailsClass).Entry = _
                New Global.Microsoft.LightSwitch.Details.Framework.Base.EntityDetails(Of __SalesOrderHeader, __SalesOrderHeader.DetailsClass).Entry( _
                    AddressOf __SalesOrderHeader.DetailsClass.__SalesOrderHeader_CreateNew, _
                    AddressOf __SalesOrderHeader.DetailsClass.__SalesOrderHeader_Created, _
                    AddressOf __SalesOrderHeader.DetailsClass.__SalesOrderHeader_AllowSaveWithErrors)
            Private Shared Function __SalesOrderHeader_CreateNew(es As Global.Microsoft.LightSwitch.Framework.EntitySet(Of __SalesOrderHeader)) As __SalesOrderHeader
                Return New __SalesOrderHeader(es)
            End Function
            Private Shared Sub __SalesOrderHeader_Created(e As __SalesOrderHeader)
                e.SalesOrderHeader_Created()
            End Sub
            Private Shared Function __SalesOrderHeader_AllowSaveWithErrors(e As __SalesOrderHeader) As Boolean
                Dim result As Boolean = False
                e.SalesOrderHeader_AllowSaveWithErrors(result)
                Return result
            End Function
    
            Public Sub New()
                MyBase.New()
            End Sub
    
            Public ReadOnly Shadows Property Commands As Global.Microsoft.LightSwitch.Details.Framework.EntityCommandSet(Of __SalesOrderHeader, __SalesOrderHeader.DetailsClass)
                Get
                    Return MyBase.Commands
                End Get
            End Property
    
            Public ReadOnly Shadows Property Methods As Global.Microsoft.LightSwitch.Details.Framework.EntityMethodSet(Of __SalesOrderHeader, __SalesOrderHeader.DetailsClass)
                Get
                    Return MyBase.Methods
                End Get
            End Property
    
            Public ReadOnly Shadows Property Properties As __SalesOrderHeader.DetailsClass.PropertySet
                Get
                    Return MyBase.Properties
                End Get
            End Property
    
            <Global.System.ComponentModel.EditorBrowsable(Global.System.ComponentModel.EditorBrowsableState.Never)> _
            <Global.System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Design", "CA1034:NestedTypesShouldNotBeVisible")> _
            <Global.System.CodeDom.Compiler.GeneratedCodeAttribute("Microsoft.LightSwitch.BuildTasks.CodeGen", "11.0.0.0")> _
            <Global.System.Diagnostics.DebuggerNonUserCodeAttribute()> _
            Public NotInheritable Class PropertySet
                Inherits Global.Microsoft.LightSwitch.Details.Framework.Base.EntityPropertySet(Of __SalesOrderHeader, __SalesOrderHeader.DetailsClass)
    
                Public Sub New()
                    MyBase.New()
                End Sub
    
                Public ReadOnly Property Id As Global.Microsoft.LightSwitch.Details.Framework.EntityStorageProperty(Of __SalesOrderHeader, __SalesOrderHeader.DetailsClass, Integer)
                    Get
                        Return TryCast(
                            MyBase.GetItem(__SalesOrderHeader.DetailsClass.PropertySetProperties.Id),
                            Global.Microsoft.LightSwitch.Details.Framework.EntityStorageProperty(Of __SalesOrderHeader, __SalesOrderHeader.DetailsClass, Integer))
                    End Get
                End Property
                
                Public ReadOnly Property RowVersion As Global.Microsoft.LightSwitch.Details.Framework.EntityStorageProperty(Of __SalesOrderHeader, __SalesOrderHeader.DetailsClass, Byte())
                    Get
                        Return TryCast(
                            MyBase.GetItem(__SalesOrderHeader.DetailsClass.PropertySetProperties.RowVersion),
                            Global.Microsoft.LightSwitch.Details.Framework.EntityStorageProperty(Of __SalesOrderHeader, __SalesOrderHeader.DetailsClass, Byte()))
                    End Get
                End Property
                
                Public ReadOnly Property OrderDate As Global.Microsoft.LightSwitch.Details.Framework.EntityStorageProperty(Of __SalesOrderHeader, __SalesOrderHeader.DetailsClass, Date)
                    Get
                        Return TryCast(
                            MyBase.GetItem(__SalesOrderHeader.DetailsClass.PropertySetProperties.OrderDate),
                            Global.Microsoft.LightSwitch.Details.Framework.EntityStorageProperty(Of __SalesOrderHeader, __SalesOrderHeader.DetailsClass, Date))
                    End Get
                End Property
                
                Public ReadOnly Property OrderTotal As Global.Microsoft.LightSwitch.Details.Framework.EntityComputedProperty(Of __SalesOrderHeader, __SalesOrderHeader.DetailsClass, Decimal)
                    Get
                        Return TryCast(
                            MyBase.GetItem(__SalesOrderHeader.DetailsClass.PropertySetProperties.OrderTotal),
                            Global.Microsoft.LightSwitch.Details.Framework.EntityComputedProperty(Of __SalesOrderHeader, __SalesOrderHeader.DetailsClass, Decimal))
                    End Get
                End Property
                
                Public ReadOnly Property AmountPaid As Global.Microsoft.LightSwitch.Details.Framework.EntityStorageProperty(Of __SalesOrderHeader, __SalesOrderHeader.DetailsClass, Decimal)
                    Get
                        Return TryCast(
                            MyBase.GetItem(__SalesOrderHeader.DetailsClass.PropertySetProperties.AmountPaid),
                            Global.Microsoft.LightSwitch.Details.Framework.EntityStorageProperty(Of __SalesOrderHeader, __SalesOrderHeader.DetailsClass, Decimal))
                    End Get
                End Property
                
                Public ReadOnly Property AmountDue As Global.Microsoft.LightSwitch.Details.Framework.EntityComputedProperty(Of __SalesOrderHeader, __SalesOrderHeader.DetailsClass, Decimal)
                    Get
                        Return TryCast(
                            MyBase.GetItem(__SalesOrderHeader.DetailsClass.PropertySetProperties.AmountDue),
                            Global.Microsoft.LightSwitch.Details.Framework.EntityComputedProperty(Of __SalesOrderHeader, __SalesOrderHeader.DetailsClass, Decimal))
                    End Get
                End Property
                
                Public ReadOnly Property Customer As Global.Microsoft.LightSwitch.Details.Framework.EntityReferenceProperty(Of __SalesOrderHeader, __SalesOrderHeader.DetailsClass, Global.LightSwitchApplication.Customer)
                    Get
                        Return TryCast(
                            MyBase.GetItem(__SalesOrderHeader.DetailsClass.PropertySetProperties.Customer),
                            Global.Microsoft.LightSwitch.Details.Framework.EntityReferenceProperty(Of __SalesOrderHeader, __SalesOrderHeader.DetailsClass, Global.LightSwitchApplication.Customer))
                    End Get
                End Property
                
                Public ReadOnly Property Employee As Global.Microsoft.LightSwitch.Details.Framework.EntityReferenceProperty(Of __SalesOrderHeader, __SalesOrderHeader.DetailsClass, Global.LightSwitchApplication.Employee)
                    Get
                        Return TryCast(
                            MyBase.GetItem(__SalesOrderHeader.DetailsClass.PropertySetProperties.Employee),
                            Global.Microsoft.LightSwitch.Details.Framework.EntityReferenceProperty(Of __SalesOrderHeader, __SalesOrderHeader.DetailsClass, Global.LightSwitchApplication.Employee))
                    End Get
                End Property
                
                Public ReadOnly Property SalesOrderDetails As Global.Microsoft.LightSwitch.Details.Framework.EntityCollectionProperty(Of __SalesOrderHeader, __SalesOrderHeader.DetailsClass, Global.LightSwitchApplication.SalesOrderDetail)
                    Get
                        Return TryCast(
                            MyBase.GetItem(__SalesOrderHeader.DetailsClass.PropertySetProperties.SalesOrderDetails),
                            Global.Microsoft.LightSwitch.Details.Framework.EntityCollectionProperty(Of __SalesOrderHeader, __SalesOrderHeader.DetailsClass, Global.LightSwitchApplication.SalesOrderDetail))
                    End Get
                End Property
                
                Public ReadOnly Property OrderPayments As Global.Microsoft.LightSwitch.Details.Framework.EntityCollectionProperty(Of __SalesOrderHeader, __SalesOrderHeader.DetailsClass, Global.LightSwitchApplication.OrderPayment)
                    Get
                        Return TryCast(
                            MyBase.GetItem(__SalesOrderHeader.DetailsClass.PropertySetProperties.OrderPayments),
                            Global.Microsoft.LightSwitch.Details.Framework.EntityCollectionProperty(Of __SalesOrderHeader, __SalesOrderHeader.DetailsClass, Global.LightSwitchApplication.OrderPayment))
                    End Get
                End Property
                
            End Class
    
            <Global.System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Design", "CA1034:NestedTypesShouldNotBeVisible")> _
            Public Interface IImplementation
                Inherits Global.Microsoft.LightSwitch.Internal.IEntityImplementation
    
                Shadows Property Id As Integer
                Shadows Property RowVersion As Byte()
                Shadows Property OrderDate As Date
                Shadows Property AmountPaid As Decimal
                Shadows Property Customer As Global.Microsoft.LightSwitch.Internal.IEntityImplementation
                Shadows Property Employee As Global.Microsoft.LightSwitch.Internal.IEntityImplementation
                Shadows ReadOnly Property SalesOrderDetails As Global.System.Collections.IEnumerable
                Shadows ReadOnly Property OrderPayments As Global.System.Collections.IEnumerable
    
            End Interface
    
            <Global.System.ComponentModel.EditorBrowsable(Global.System.ComponentModel.EditorBrowsableState.Never)> _
            <Global.System.CodeDom.Compiler.GeneratedCodeAttribute("Microsoft.LightSwitch.BuildTasks.CodeGen", "11.0.0.0")> _
            <Global.System.Diagnostics.DebuggerNonUserCodeAttribute()> _
            Friend Class PropertySetProperties
    
                <Global.System.Diagnostics.DebuggerBrowsable(Global.System.Diagnostics.DebuggerBrowsableState.Never)> _
                Public Shared ReadOnly Id As Global.Microsoft.LightSwitch.Details.Framework.EntityStorageProperty(Of __SalesOrderHeader, __SalesOrderHeader.DetailsClass, Integer).Entry = _
                    New Global.Microsoft.LightSwitch.Details.Framework.EntityStorageProperty(Of __SalesOrderHeader, __SalesOrderHeader.DetailsClass, Integer).Entry( _
                        "Id", _
                        AddressOf __SalesOrderHeader.DetailsClass.PropertySetProperties._Id_Stub, _
                        AddressOf __SalesOrderHeader.DetailsClass.PropertySetProperties._Id_ComputeIsReadOnly, _
                        AddressOf __SalesOrderHeader.DetailsClass.PropertySetProperties._Id_Validate, _
                        AddressOf __SalesOrderHeader.DetailsClass.PropertySetProperties._Id_GetImplementationValue, _
                        AddressOf __SalesOrderHeader.DetailsClass.PropertySetProperties._Id_SetImplementationValue, _
                        AddressOf __SalesOrderHeader.DetailsClass.PropertySetProperties._Id_OnValueChanged)
                Private Shared Sub _Id_Stub(c As Global.Microsoft.LightSwitch.Details.Framework.Base.DetailsCallback(Of __SalesOrderHeader.DetailsClass, Global.Microsoft.LightSwitch.Details.Framework.EntityStorageProperty(Of __SalesOrderHeader, __SalesOrderHeader.DetailsClass, Integer).Data), d As __SalesOrderHeader.DetailsClass, sf As Object)
                    c(d, d._Id, sf)
                End Sub
                Private Shared Function _Id_ComputeIsReadOnly(e As __SalesOrderHeader) As Boolean
                    Dim result As Boolean = False
                    e.Id_IsReadOnly(result)
                    Return result
                End Function
                Private Shared Sub _Id_Validate(e As __SalesOrderHeader, r As Global.Microsoft.LightSwitch.EntityValidationResultsBuilder)
                    e.Id_Validate(r)
                End Sub
                Private Shared Function _Id_GetImplementationValue(d As __SalesOrderHeader.DetailsClass) As Integer
                    Return d.ImplementationEntity.Id
                End Function
                Private Shared Sub _Id_SetImplementationValue(d As __SalesOrderHeader.DetailsClass, v As Integer)
                    d.ImplementationEntity.Id = v
                End Sub
                Private Shared Sub _Id_OnValueChanged(e As __SalesOrderHeader)
                    e.Id_Changed()
                End Sub
    
                <Global.System.Diagnostics.DebuggerBrowsable(Global.System.Diagnostics.DebuggerBrowsableState.Never)> _
                Public Shared ReadOnly RowVersion As Global.Microsoft.LightSwitch.Details.Framework.EntityStorageProperty(Of __SalesOrderHeader, __SalesOrderHeader.DetailsClass, Byte()).Entry = _
                    New Global.Microsoft.LightSwitch.Details.Framework.EntityStorageProperty(Of __SalesOrderHeader, __SalesOrderHeader.DetailsClass, Byte()).Entry( _
                        "RowVersion", _
                        AddressOf __SalesOrderHeader.DetailsClass.PropertySetProperties._RowVersion_Stub, _
                        AddressOf __SalesOrderHeader.DetailsClass.PropertySetProperties._RowVersion_ComputeIsReadOnly, _
                        AddressOf __SalesOrderHeader.DetailsClass.PropertySetProperties._RowVersion_Validate, _
                        AddressOf __SalesOrderHeader.DetailsClass.PropertySetProperties._RowVersion_GetImplementationValue, _
                        AddressOf __SalesOrderHeader.DetailsClass.PropertySetProperties._RowVersion_SetImplementationValue, _
                        AddressOf __SalesOrderHeader.DetailsClass.PropertySetProperties._RowVersion_OnValueChanged)
                Private Shared Sub _RowVersion_Stub(c As Global.Microsoft.LightSwitch.Details.Framework.Base.DetailsCallback(Of __SalesOrderHeader.DetailsClass, Global.Microsoft.LightSwitch.Details.Framework.EntityStorageProperty(Of __SalesOrderHeader, __SalesOrderHeader.DetailsClass, Byte()).Data), d As __SalesOrderHeader.DetailsClass, sf As Object)
                    c(d, d._RowVersion, sf)
                End Sub
                Private Shared Function _RowVersion_ComputeIsReadOnly(e As __SalesOrderHeader) As Boolean
                    Dim result As Boolean = False
                    e.RowVersion_IsReadOnly(result)
                    Return result
                End Function
                Private Shared Sub _RowVersion_Validate(e As __SalesOrderHeader, r As Global.Microsoft.LightSwitch.EntityValidationResultsBuilder)
                    e.RowVersion_Validate(r)
                End Sub
                Private Shared Function _RowVersion_GetImplementationValue(d As __SalesOrderHeader.DetailsClass) As Byte()
                    Return d.ImplementationEntity.RowVersion
                End Function
                Private Shared Sub _RowVersion_SetImplementationValue(d As __SalesOrderHeader.DetailsClass, v As Byte())
                    d.ImplementationEntity.RowVersion = v
                End Sub
                Private Shared Sub _RowVersion_OnValueChanged(e As __SalesOrderHeader)
                    e.RowVersion_Changed()
                End Sub
    
                <Global.System.Diagnostics.DebuggerBrowsable(Global.System.Diagnostics.DebuggerBrowsableState.Never)> _
                Public Shared ReadOnly OrderDate As Global.Microsoft.LightSwitch.Details.Framework.EntityStorageProperty(Of __SalesOrderHeader, __SalesOrderHeader.DetailsClass, Date).Entry = _
                    New Global.Microsoft.LightSwitch.Details.Framework.EntityStorageProperty(Of __SalesOrderHeader, __SalesOrderHeader.DetailsClass, Date).Entry( _
                        "OrderDate", _
                        AddressOf __SalesOrderHeader.DetailsClass.PropertySetProperties._OrderDate_Stub, _
                        AddressOf __SalesOrderHeader.DetailsClass.PropertySetProperties._OrderDate_ComputeIsReadOnly, _
                        AddressOf __SalesOrderHeader.DetailsClass.PropertySetProperties._OrderDate_Validate, _
                        AddressOf __SalesOrderHeader.DetailsClass.PropertySetProperties._OrderDate_GetImplementationValue, _
                        AddressOf __SalesOrderHeader.DetailsClass.PropertySetProperties._OrderDate_SetImplementationValue, _
                        AddressOf __SalesOrderHeader.DetailsClass.PropertySetProperties._OrderDate_OnValueChanged)
                Private Shared Sub _OrderDate_Stub(c As Global.Microsoft.LightSwitch.Details.Framework.Base.DetailsCallback(Of __SalesOrderHeader.DetailsClass, Global.Microsoft.LightSwitch.Details.Framework.EntityStorageProperty(Of __SalesOrderHeader, __SalesOrderHeader.DetailsClass, Date).Data), d As __SalesOrderHeader.DetailsClass, sf As Object)
                    c(d, d._OrderDate, sf)
                End Sub
                Private Shared Function _OrderDate_ComputeIsReadOnly(e As __SalesOrderHeader) As Boolean
                    Dim result As Boolean = False
                    e.OrderDate_IsReadOnly(result)
                    Return result
                End Function
                Private Shared Sub _OrderDate_Validate(e As __SalesOrderHeader, r As Global.Microsoft.LightSwitch.EntityValidationResultsBuilder)
                    e.OrderDate_Validate(r)
                End Sub
                Private Shared Function _OrderDate_GetImplementationValue(d As __SalesOrderHeader.DetailsClass) As Date
                    Return d.ImplementationEntity.OrderDate
                End Function
                Private Shared Sub _OrderDate_SetImplementationValue(d As __SalesOrderHeader.DetailsClass, v As Date)
                    d.ImplementationEntity.OrderDate = __SalesOrderHeader.DetailsClass.TruncateDate(v)
                End Sub
                Private Shared Sub _OrderDate_OnValueChanged(e As __SalesOrderHeader)
                    e.OrderDate_Changed()
                End Sub
    
                <Global.System.Diagnostics.DebuggerBrowsable(Global.System.Diagnostics.DebuggerBrowsableState.Never)> _
                Public Shared ReadOnly OrderTotal As Global.Microsoft.LightSwitch.Details.Framework.EntityComputedProperty(Of __SalesOrderHeader, __SalesOrderHeader.DetailsClass, Decimal).Entry = _
                    New Global.Microsoft.LightSwitch.Details.Framework.EntityComputedProperty(Of __SalesOrderHeader, __SalesOrderHeader.DetailsClass, Decimal).Entry( _
                        "OrderTotal", _
                        AddressOf __SalesOrderHeader.DetailsClass.PropertySetProperties._OrderTotal_Stub, _
                        AddressOf __SalesOrderHeader.DetailsClass.PropertySetProperties._OrderTotal_Validate, _
                        AddressOf __SalesOrderHeader.DetailsClass.PropertySetProperties._OrderTotal_ComputeValue)
                Private Shared Sub _OrderTotal_Stub(c As Global.Microsoft.LightSwitch.Details.Framework.Base.DetailsCallback(Of __SalesOrderHeader.DetailsClass, Global.Microsoft.LightSwitch.Details.Framework.EntityComputedProperty(Of __SalesOrderHeader, __SalesOrderHeader.DetailsClass, Decimal).Data), d As __SalesOrderHeader.DetailsClass, sf As Object)
                    c(d, d._OrderTotal, sf)
                End Sub
                Private Shared Sub _OrderTotal_Validate(e As __SalesOrderHeader, r As Global.Microsoft.LightSwitch.EntityValidationResultsBuilder)
                    e.OrderTotal_Validate(r)
                End Sub
                Private Shared Function _OrderTotal_ComputeValue(e As __SalesOrderHeader) As Decimal
                    Dim value As Decimal = Nothing
                    e.OrderTotal_Compute(value)
                    Return value
                End Function
    
                <Global.System.Diagnostics.DebuggerBrowsable(Global.System.Diagnostics.DebuggerBrowsableState.Never)> _
                Public Shared ReadOnly AmountPaid As Global.Microsoft.LightSwitch.Details.Framework.EntityStorageProperty(Of __SalesOrderHeader, __SalesOrderHeader.DetailsClass, Decimal).Entry = _
                    New Global.Microsoft.LightSwitch.Details.Framework.EntityStorageProperty(Of __SalesOrderHeader, __SalesOrderHeader.DetailsClass, Decimal).Entry( _
                        "AmountPaid", _
                        AddressOf __SalesOrderHeader.DetailsClass.PropertySetProperties._AmountPaid_Stub, _
                        AddressOf __SalesOrderHeader.DetailsClass.PropertySetProperties._AmountPaid_ComputeIsReadOnly, _
                        AddressOf __SalesOrderHeader.DetailsClass.PropertySetProperties._AmountPaid_Validate, _
                        AddressOf __SalesOrderHeader.DetailsClass.PropertySetProperties._AmountPaid_GetImplementationValue, _
                        AddressOf __SalesOrderHeader.DetailsClass.PropertySetProperties._AmountPaid_SetImplementationValue, _
                        AddressOf __SalesOrderHeader.DetailsClass.PropertySetProperties._AmountPaid_OnValueChanged)
                Private Shared Sub _AmountPaid_Stub(c As Global.Microsoft.LightSwitch.Details.Framework.Base.DetailsCallback(Of __SalesOrderHeader.DetailsClass, Global.Microsoft.LightSwitch.Details.Framework.EntityStorageProperty(Of __SalesOrderHeader, __SalesOrderHeader.DetailsClass, Decimal).Data), d As __SalesOrderHeader.DetailsClass, sf As Object)
                    c(d, d._AmountPaid, sf)
                End Sub
                Private Shared Function _AmountPaid_ComputeIsReadOnly(e As __SalesOrderHeader) As Boolean
                    Dim result As Boolean = False
                    e.AmountPaid_IsReadOnly(result)
                    Return result
                End Function
                Private Shared Sub _AmountPaid_Validate(e As __SalesOrderHeader, r As Global.Microsoft.LightSwitch.EntityValidationResultsBuilder)
                    e.AmountPaid_Validate(r)
                End Sub
                Private Shared Function _AmountPaid_GetImplementationValue(d As __SalesOrderHeader.DetailsClass) As Decimal
                    Return d.ImplementationEntity.AmountPaid
                End Function
                Private Shared Sub _AmountPaid_SetImplementationValue(d As __SalesOrderHeader.DetailsClass, v As Decimal)
                    d.ImplementationEntity.AmountPaid = v
                End Sub
                Private Shared Sub _AmountPaid_OnValueChanged(e As __SalesOrderHeader)
                    e.AmountPaid_Changed()
                End Sub
    
                <Global.System.Diagnostics.DebuggerBrowsable(Global.System.Diagnostics.DebuggerBrowsableState.Never)> _
                Public Shared ReadOnly AmountDue As Global.Microsoft.LightSwitch.Details.Framework.EntityComputedProperty(Of __SalesOrderHeader, __SalesOrderHeader.DetailsClass, Decimal).Entry = _
                    New Global.Microsoft.LightSwitch.Details.Framework.EntityComputedProperty(Of __SalesOrderHeader, __SalesOrderHeader.DetailsClass, Decimal).Entry( _
                        "AmountDue", _
                        AddressOf __SalesOrderHeader.DetailsClass.PropertySetProperties._AmountDue_Stub, _
                        AddressOf __SalesOrderHeader.DetailsClass.PropertySetProperties._AmountDue_Validate, _
                        AddressOf __SalesOrderHeader.DetailsClass.PropertySetProperties._AmountDue_ComputeValue)
                Private Shared Sub _AmountDue_Stub(c As Global.Microsoft.LightSwitch.Details.Framework.Base.DetailsCallback(Of __SalesOrderHeader.DetailsClass, Global.Microsoft.LightSwitch.Details.Framework.EntityComputedProperty(Of __SalesOrderHeader, __SalesOrderHeader.DetailsClass, Decimal).Data), d As __SalesOrderHeader.DetailsClass, sf As Object)
                    c(d, d._AmountDue, sf)
                End Sub
                Private Shared Sub _AmountDue_Validate(e As __SalesOrderHeader, r As Global.Microsoft.LightSwitch.EntityValidationResultsBuilder)
                    e.AmountDue_Validate(r)
                End Sub
                Private Shared Function _AmountDue_ComputeValue(e As __SalesOrderHeader) As Decimal
                    Dim value As Decimal = Nothing
                    e.AmountDue_Compute(value)
                    Return value
                End Function
    
                <Global.System.Diagnostics.DebuggerBrowsable(Global.System.Diagnostics.DebuggerBrowsableState.Never)> _
                Public Shared ReadOnly Customer As Global.Microsoft.LightSwitch.Details.Framework.EntityReferenceProperty(Of __SalesOrderHeader, __SalesOrderHeader.DetailsClass, Global.LightSwitchApplication.Customer).Entry = _
                    New Global.Microsoft.LightSwitch.Details.Framework.EntityReferenceProperty(Of __SalesOrderHeader, __SalesOrderHeader.DetailsClass, Global.LightSwitchApplication.Customer).Entry( _
                        "Customer", _
                        AddressOf __SalesOrderHeader.DetailsClass.PropertySetProperties._Customer_Stub, _
                        AddressOf __SalesOrderHeader.DetailsClass.PropertySetProperties._Customer_ComputeIsReadOnly, _
                        AddressOf __SalesOrderHeader.DetailsClass.PropertySetProperties._Customer_Validate, _
                        AddressOf __SalesOrderHeader.DetailsClass.PropertySetProperties._Customer_GetCoreImplementationValue, _
                        AddressOf __SalesOrderHeader.DetailsClass.PropertySetProperties._Customer_GetImplementationValue, _
                        AddressOf __SalesOrderHeader.DetailsClass.PropertySetProperties._Customer_SetImplementationValue, _
                        AddressOf __SalesOrderHeader.DetailsClass.PropertySetProperties._Customer_Refresh, _
                        AddressOf __SalesOrderHeader.DetailsClass.PropertySetProperties._Customer_OnValueChanged)
                Private Shared Sub _Customer_Stub(c As Global.Microsoft.LightSwitch.Details.Framework.Base.DetailsCallback(Of __SalesOrderHeader.DetailsClass, Global.Microsoft.LightSwitch.Details.Framework.EntityReferenceProperty(Of __SalesOrderHeader, __SalesOrderHeader.DetailsClass, Global.LightSwitchApplication.Customer).Data), d As __SalesOrderHeader.DetailsClass, sf As Object)
                    c(d, d._Customer, sf)
                End Sub
                Private Shared Function _Customer_ComputeIsReadOnly(e As __SalesOrderHeader) As Boolean
                    Dim result As Boolean = False
                    e.Customer_IsReadOnly(result)
                    Return result
                End Function
                Private Shared Sub _Customer_Validate(e As __SalesOrderHeader, r As Global.Microsoft.LightSwitch.EntityValidationResultsBuilder)
                    e.Customer_Validate(r)
                End Sub
                Private Shared Function _Customer_GetCoreImplementationValue(d as __SalesOrderHeader.DetailsClass) As Global.Microsoft.LightSwitch.Internal.IEntityImplementation
                    Return d.ImplementationEntity.Customer
                End Function
                Private Shared Function _Customer_GetImplementationValue(d as __SalesOrderHeader.DetailsClass) As Global.LightSwitchApplication.Customer
                    Return d.GetImplementationValue(Of Global.LightSwitchApplication.Customer, Global.LightSwitchApplication.Customer.DetailsClass)(__SalesOrderHeader.DetailsClass.PropertySetProperties.Customer, d._Customer)
                End Function
                Private Shared Sub _Customer_SetImplementationValue(d As __SalesOrderHeader.DetailsClass, v As Global.LightSwitchApplication.Customer)
                    d.SetImplementationValue(__SalesOrderHeader.DetailsClass.PropertySetProperties.Customer, d._Customer, Sub(i, ev) i.Customer = ev, v)
                End Sub
                Private Shared Sub _Customer_Refresh(d As __SalesOrderHeader.DetailsClass)
                    d.RefreshNavigationProperty(__SalesOrderHeader.DetailsClass.PropertySetProperties.Customer, d._Customer)
                End Sub
                Private Shared Sub _Customer_OnValueChanged(e As __SalesOrderHeader)
                    e.Customer_Changed()
                End Sub
    
                <Global.System.Diagnostics.DebuggerBrowsable(Global.System.Diagnostics.DebuggerBrowsableState.Never)> _
                Public Shared ReadOnly Employee As Global.Microsoft.LightSwitch.Details.Framework.EntityReferenceProperty(Of __SalesOrderHeader, __SalesOrderHeader.DetailsClass, Global.LightSwitchApplication.Employee).Entry = _
                    New Global.Microsoft.LightSwitch.Details.Framework.EntityReferenceProperty(Of __SalesOrderHeader, __SalesOrderHeader.DetailsClass, Global.LightSwitchApplication.Employee).Entry( _
                        "Employee", _
                        AddressOf __SalesOrderHeader.DetailsClass.PropertySetProperties._Employee_Stub, _
                        AddressOf __SalesOrderHeader.DetailsClass.PropertySetProperties._Employee_ComputeIsReadOnly, _
                        AddressOf __SalesOrderHeader.DetailsClass.PropertySetProperties._Employee_Validate, _
                        AddressOf __SalesOrderHeader.DetailsClass.PropertySetProperties._Employee_GetCoreImplementationValue, _
                        AddressOf __SalesOrderHeader.DetailsClass.PropertySetProperties._Employee_GetImplementationValue, _
                        AddressOf __SalesOrderHeader.DetailsClass.PropertySetProperties._Employee_SetImplementationValue, _
                        AddressOf __SalesOrderHeader.DetailsClass.PropertySetProperties._Employee_Refresh, _
                        AddressOf __SalesOrderHeader.DetailsClass.PropertySetProperties._Employee_OnValueChanged)
                Private Shared Sub _Employee_Stub(c As Global.Microsoft.LightSwitch.Details.Framework.Base.DetailsCallback(Of __SalesOrderHeader.DetailsClass, Global.Microsoft.LightSwitch.Details.Framework.EntityReferenceProperty(Of __SalesOrderHeader, __SalesOrderHeader.DetailsClass, Global.LightSwitchApplication.Employee).Data), d As __SalesOrderHeader.DetailsClass, sf As Object)
                    c(d, d._Employee, sf)
                End Sub
                Private Shared Function _Employee_ComputeIsReadOnly(e As __SalesOrderHeader) As Boolean
                    Dim result As Boolean = False
                    e.Employee_IsReadOnly(result)
                    Return result
                End Function
                Private Shared Sub _Employee_Validate(e As __SalesOrderHeader, r As Global.Microsoft.LightSwitch.EntityValidationResultsBuilder)
                    e.Employee_Validate(r)
                End Sub
                Private Shared Function _Employee_GetCoreImplementationValue(d as __SalesOrderHeader.DetailsClass) As Global.Microsoft.LightSwitch.Internal.IEntityImplementation
                    Return d.ImplementationEntity.Employee
                End Function
                Private Shared Function _Employee_GetImplementationValue(d as __SalesOrderHeader.DetailsClass) As Global.LightSwitchApplication.Employee
                    Return d.GetImplementationValue(Of Global.LightSwitchApplication.Employee, Global.LightSwitchApplication.Employee.DetailsClass)(__SalesOrderHeader.DetailsClass.PropertySetProperties.Employee, d._Employee)
                End Function
                Private Shared Sub _Employee_SetImplementationValue(d As __SalesOrderHeader.DetailsClass, v As Global.LightSwitchApplication.Employee)
                    d.SetImplementationValue(__SalesOrderHeader.DetailsClass.PropertySetProperties.Employee, d._Employee, Sub(i, ev) i.Employee = ev, v)
                End Sub
                Private Shared Sub _Employee_Refresh(d As __SalesOrderHeader.DetailsClass)
                    d.RefreshNavigationProperty(__SalesOrderHeader.DetailsClass.PropertySetProperties.Employee, d._Employee)
                End Sub
                Private Shared Sub _Employee_OnValueChanged(e As __SalesOrderHeader)
                    e.Employee_Changed()
                End Sub
    
                <Global.System.Diagnostics.DebuggerBrowsable(Global.System.Diagnostics.DebuggerBrowsableState.Never)> _
                Public Shared ReadOnly SalesOrderDetails As Global.Microsoft.LightSwitch.Details.Framework.EntityCollectionProperty(Of __SalesOrderHeader, __SalesOrderHeader.DetailsClass, Global.LightSwitchApplication.SalesOrderDetail).Entry = _
                    New Global.Microsoft.LightSwitch.Details.Framework.EntityCollectionProperty(Of __SalesOrderHeader, __SalesOrderHeader.DetailsClass, Global.LightSwitchApplication.SalesOrderDetail).Entry( _
                        "SalesOrderDetails", _
                        AddressOf __SalesOrderHeader.DetailsClass.PropertySetProperties._SalesOrderDetails_Stub, _
                        AddressOf __SalesOrderHeader.DetailsClass.PropertySetProperties._SalesOrderDetails_GetReferencedEntities, _
                        AddressOf __SalesOrderHeader.DetailsClass.PropertySetProperties._SalesOrderDetails_GetEntityCollection)
                Private Shared Sub _SalesOrderDetails_Stub(c As Global.Microsoft.LightSwitch.Details.Framework.Base.DetailsCallback(Of __SalesOrderHeader.DetailsClass, Global.Microsoft.LightSwitch.Details.Framework.EntityCollectionProperty(Of __SalesOrderHeader, __SalesOrderHeader.DetailsClass, Global.LightSwitchApplication.SalesOrderDetail).Data), d As __SalesOrderHeader.DetailsClass, sf As Object)
                    c(d, d._SalesOrderDetails, sf)
                End Sub
                Private Shared Function _SalesOrderDetails_GetReferencedEntities(d As __SalesOrderHeader.DetailsClass) As Global.System.Collections.Generic.IEnumerable(Of Global.LightSwitchApplication.SalesOrderDetail)
                    Return d.GetReferencedEntities(Of Global.LightSwitchApplication.SalesOrderDetail, Global.LightSwitchApplication.SalesOrderDetail.DetailsClass)(__SalesOrderHeader.DetailsClass.PropertySetProperties.SalesOrderDetails, d._SalesOrderDetails)
                End Function
                Private Shared Function _SalesOrderDetails_GetEntityCollection(d As __SalesOrderHeader.DetailsClass) As Global.System.Collections.IEnumerable
                    Return d.ImplementationEntity.SalesOrderDetails
                End Function
    
                <Global.System.Diagnostics.DebuggerBrowsable(Global.System.Diagnostics.DebuggerBrowsableState.Never)> _
                Public Shared ReadOnly OrderPayments As Global.Microsoft.LightSwitch.Details.Framework.EntityCollectionProperty(Of __SalesOrderHeader, __SalesOrderHeader.DetailsClass, Global.LightSwitchApplication.OrderPayment).Entry = _
                    New Global.Microsoft.LightSwitch.Details.Framework.EntityCollectionProperty(Of __SalesOrderHeader, __SalesOrderHeader.DetailsClass, Global.LightSwitchApplication.OrderPayment).Entry( _
                        "OrderPayments", _
                        AddressOf __SalesOrderHeader.DetailsClass.PropertySetProperties._OrderPayments_Stub, _
                        AddressOf __SalesOrderHeader.DetailsClass.PropertySetProperties._OrderPayments_GetReferencedEntities, _
                        AddressOf __SalesOrderHeader.DetailsClass.PropertySetProperties._OrderPayments_GetEntityCollection)
                Private Shared Sub _OrderPayments_Stub(c As Global.Microsoft.LightSwitch.Details.Framework.Base.DetailsCallback(Of __SalesOrderHeader.DetailsClass, Global.Microsoft.LightSwitch.Details.Framework.EntityCollectionProperty(Of __SalesOrderHeader, __SalesOrderHeader.DetailsClass, Global.LightSwitchApplication.OrderPayment).Data), d As __SalesOrderHeader.DetailsClass, sf As Object)
                    c(d, d._OrderPayments, sf)
                End Sub
                Private Shared Function _OrderPayments_GetReferencedEntities(d As __SalesOrderHeader.DetailsClass) As Global.System.Collections.Generic.IEnumerable(Of Global.LightSwitchApplication.OrderPayment)
                    Return d.GetReferencedEntities(Of Global.LightSwitchApplication.OrderPayment, Global.LightSwitchApplication.OrderPayment.DetailsClass)(__SalesOrderHeader.DetailsClass.PropertySetProperties.OrderPayments, d._OrderPayments)
                End Function
                Private Shared Function _OrderPayments_GetEntityCollection(d As __SalesOrderHeader.DetailsClass) As Global.System.Collections.IEnumerable
                    Return d.ImplementationEntity.OrderPayments
                End Function
    
            End Class
    
            <Global.System.Diagnostics.DebuggerBrowsable(Global.System.Diagnostics.DebuggerBrowsableState.Never)> _
            Private _Id As Global.Microsoft.LightSwitch.Details.Framework.EntityStorageProperty(Of __SalesOrderHeader, __SalesOrderHeader.DetailsClass, Integer).Data
            
            <Global.System.Diagnostics.DebuggerBrowsable(Global.System.Diagnostics.DebuggerBrowsableState.Never)> _
            Private _RowVersion As Global.Microsoft.LightSwitch.Details.Framework.EntityStorageProperty(Of __SalesOrderHeader, __SalesOrderHeader.DetailsClass, Byte()).Data
            
            <Global.System.Diagnostics.DebuggerBrowsable(Global.System.Diagnostics.DebuggerBrowsableState.Never)> _
            Private _OrderDate As Global.Microsoft.LightSwitch.Details.Framework.EntityStorageProperty(Of __SalesOrderHeader, __SalesOrderHeader.DetailsClass, Date).Data
            
            <Global.System.Diagnostics.DebuggerBrowsable(Global.System.Diagnostics.DebuggerBrowsableState.Never)> _
            Private _OrderTotal As Global.Microsoft.LightSwitch.Details.Framework.EntityComputedProperty(Of __SalesOrderHeader, __SalesOrderHeader.DetailsClass, Decimal).Data
            
            <Global.System.Diagnostics.DebuggerBrowsable(Global.System.Diagnostics.DebuggerBrowsableState.Never)> _
            Private _AmountPaid As Global.Microsoft.LightSwitch.Details.Framework.EntityStorageProperty(Of __SalesOrderHeader, __SalesOrderHeader.DetailsClass, Decimal).Data
            
            <Global.System.Diagnostics.DebuggerBrowsable(Global.System.Diagnostics.DebuggerBrowsableState.Never)> _
            Private _AmountDue As Global.Microsoft.LightSwitch.Details.Framework.EntityComputedProperty(Of __SalesOrderHeader, __SalesOrderHeader.DetailsClass, Decimal).Data
            
            <Global.System.Diagnostics.DebuggerBrowsable(Global.System.Diagnostics.DebuggerBrowsableState.Never)> _
            Private _Customer As Global.Microsoft.LightSwitch.Details.Framework.EntityReferenceProperty(Of __SalesOrderHeader, __SalesOrderHeader.DetailsClass, Global.LightSwitchApplication.Customer).Data
            
            <Global.System.Diagnostics.DebuggerBrowsable(Global.System.Diagnostics.DebuggerBrowsableState.Never)> _
            Private _Employee As Global.Microsoft.LightSwitch.Details.Framework.EntityReferenceProperty(Of __SalesOrderHeader, __SalesOrderHeader.DetailsClass, Global.LightSwitchApplication.Employee).Data
            
            <Global.System.Diagnostics.DebuggerBrowsable(Global.System.Diagnostics.DebuggerBrowsableState.Never)> _
            Private _SalesOrderDetails As Global.Microsoft.LightSwitch.Details.Framework.EntityCollectionProperty(Of __SalesOrderHeader, __SalesOrderHeader.DetailsClass, Global.LightSwitchApplication.SalesOrderDetail).Data
            
            <Global.System.Diagnostics.DebuggerBrowsable(Global.System.Diagnostics.DebuggerBrowsableState.Never)> _
            Private _OrderPayments As Global.Microsoft.LightSwitch.Details.Framework.EntityCollectionProperty(Of __SalesOrderHeader, __SalesOrderHeader.DetailsClass, Global.LightSwitchApplication.OrderPayment).Data
            
        End Class
    
        #End Region
    
    End Class
    
    #End Region
End Namespace
